%{
/**************************************************************
* File Name   : subc.l
*
* Description
*	This is a skeleton input file to lex.
*
* Which tool to use
*	The GNU lex-clone, flex/flex++ is recommended to use.
*	It supports a C++ mode.
*	For any information about flex, refer to flex.man.
*
*	Good Luck!
*
***************************************************************/

/**************************************************************/
/* This section will appear at the head of lex.yy.c/lex.yy.cc */
/**************************************************************/

#include "subc.h"
/***************************************************************
{Other useful code segments can be here.}
***************************************************************/
int commentdepth=0;
%}

/* You can put any meaningful regular definitions */
letter		[A-Za-z_]
digit		[0-9]
alphaNum	{letter}|{digit}
whiteChar	[ \t\n]
integer		[1-9]{digit}*
name		{letter}+
op1		[+-=]
op2 		(\(|\)|\{|\}|\;)
operator	{op1}|{op2}
whitespace	[ \t\n]+

%start AA BB
%x CC
%%

{integer}	{
}
<AA>{operator}	{
}

<AA>{name}	{
		int i;
		struct id* tmp;
		tmp=enter(NAME, yytext, yyleng);
}
<CC>{whitespace}+ {
}
%%
void initHash() {
	int i;
	char* keyWord[]={
		"int","return", "\0"
		};
	/* Initilize Hash Tabel with Keywords */
	for( i=0; strcmp(keyWord[i], "\0")!=0 ; i++) {
		enter(KEYWORD,keyWord[i],strlen(keyWord[i]));
	}
}

int main (int argc, char** argv)
{
	struct id* temp;
	++argv, --argc;
	if (argc > 0) {
		yyin = fopen (argv[0], "r");
	} else {
		yyin = stdin;
	}
	initHash();
	BEGIN AA;
	yylex ();
	return 0;
}
